ECALC9F  is an ICOOL utility that reads file for009.dat
and performs a standardized emittance and lattice function analysis.
It is a slight modification of version 2 of Gregg Penn's code ECALC9 with 
the selection of parameters read in from a file instead of from the keyboard. This form
is somewhat more convenient for repeated application of the same cuts and
for running the program from a script.

Usage:  > ecalc9f

Input files:    for009.dat
		ecalc9f.inp

Ouput files:    ecalc9f.dat
		ecalc9f.cut (optional)

The data required for ecalc9f.inp are

title                   (ascii)
ICOOL particle type     (int)	{muon = +/- 2}
pzmin,pzmax             (real)  [GeV/c]
transcutA,transcutB     (real)  [m]
longcut                 (real)  [m]
rffreq                  (real)  [MHz]
sigmacut                (real)	tail cut
pzcorr                  (log)	if true => makes correction for pz-AT correlation
wrnew9			(log)	if true => writes new file ecalc9f.cut identifying
				 particles inside transcutA and longcut
